/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Aug 2009

 File          : View_ECLK_1.c

 Hardware      : Applicable to ADuC7038

 Description   : This routine Sets the ECLK on GPIO_5.

	Oscillator	 This clock is 2.56MHZ nominal - 20 x the 128KHz oscillator
				 The user can vary	POWCON to set the Low power Oscillator - 3%
				 or the Precision oscillator - 1%  , measure the 2.56MHZ clock 
				 and Divide by 20 for 128KHz measurement. 

*********************************************************************/

#include <ADuC7038.h>

void delay(int);
unsigned int Any_status	= 0;

int main()
{
	unsigned long it1=1234, it2=4321;
									// SET 10.24 MEg PLL
 	POWKEY0 = 0x01;		 			// Put all peripherals, PLL and Core Asleep
	POWCON	 = 0x179;				// 0001 0111 1001 default value is 79	- 10MHz	/ 1% prec
	POWKEY1 = 0xF4;					// 
	it1 = it1*it2;					// Dummy cycle to ensure correct power down 

    delay(20000);					// Delay after enabling 1% osc - PLLCON

	PLLKEY0 = 0x000000AA;
	PLLCON  = 0x01;        	 /* Intern 1% Oszillator  Precision   */
	PLLKEY1 = 0x00000055;
	it1 = it1*it2;			// Dummy cycle to ensure correct power down

    delay(20000);					// Delay after enabling 1% osc - PLLCON

	Any_status = PLLSTA;	// check Lock
	do 
		{
		Any_status = PLLSTA;
		}
	while ((Any_status & 0x02) != 2);

  	GPCON = 0x00200000;				//Enable (GPIO 5 as ECLK) and all others as ouputs.
							// View on Scope  - Divide by 20 for precision Measurment on 128 KHz clock
	GPDAT = 0x3F3f0000;				
	GPSET = 0x00030000;				// View Pulse on Scope - ensures that PLL Lock occurred !
	GPCLR = 0x00030000;				// Set all bits to Zero

	while(1)				
	{
	}    						// Infinite Loop
}

void delay (int length){
	while (length >=0)
    	length--;
}
